/*
 * IP 'id' port scanner
 *
 * marvin@nss.nu
 *
 * Totally untracable portscanner [0]
 *
 * -------------------------------------------
 *  THIS PROGRAM MAY NOT BE PUT ON AntiOnline
 * -------------------------------------------
 *
 * TODO:
 *   Implement icmp ip id echos
 *   Random port scanning
 *   Multiple silent hosts
 *
 * [0] If you don't know how to use this progam in an untracable way
 *     then you don't deserve to use it. [1]
 *
 * [1] Of course you *can* be traced, but if you comply with [0] then
 *     you prolly already knew how and why. This is just the most untracable
 *     way I have ever heard of. Even more so now that every admin worth
 *     his/her name has set up syn-scan (halfscan) logging.
 *
 * BTW: this program is script-kiddie-disabled. Find the "bug".
 *
 */
// #include <std_disclaimer.h>
#include <stdio.h>
#include <getopt.h>
#include <libnet.h>
#include <pcap.h>
#include "get_ipid.h"

const char *version = "1.0beta1";
const char *default_ports = "0-1024,6000-6010,8080,12345,31337";
int timeout = 10;
int offset = 1;
int sleeptime = 1;
int verbose = 0;
int silentport = 0;
int retries = 3;
int silentflags = 0;
int dstflags = TH_SYN;
int lendian = 0;

int getoffset(void)
{
  if (lendian) {
    return htons(offset);
  }
  return offset;
}

/*
 *
 */
void usage(int ret)
{
  printf("usage: ipidscan [ options ] [ -d <victim> -s <silent host> | -c <host> ]\n\n"
	 "Command:\n"
	 "   -d <host>       Target host\n"
	 "   -s <host>       Silent host\n"
	 "or:\n"
	 "   -c <host>       Check if host is silent (use with -w)\n"
	 "or:\n"
	 "   -h              Show this help text\n"
	 "\n"
	 "Options:\n"
	 "   -v              Verbose (use twice for more garbage)\n"
	 "\n"
	 "   -p <string>     Ports to scan (default: '%s')\n"
	 "   -f <tcpflags>   TCP flags to send to target host (default: s)\n"
	 "\n"
	 "   -T <port>       Port on silent host that 'echoes' (default: %d)\n"
	 //	 "   -I              Use ICMP echo for getting ip id\n"
	 "   -F <tcpflags>   TCP flags to send silent host (default: none)\n"
	 "   -o <offset>     Silent host IP id increment (default: %d, windows uses 256)\n"
	 "   -e              Don't change endianess from ipid\n"
	 "   -i <interface>  Interface to get my addr from (default: first found)\n"
	 "\n"
	 "   -w <microsec>   Microseconds to wait before getting second IP id (default: %d)\n"
	 "   -t <seconds>    Timeout when waiting for ip id (default: %d)\n"
	 "   -r <retries>    Number of retries getting ip id  (default: %d)\n"
	 "\n"
	 "Flags: (only use first letter)\n"
	 "   Ack, Syn, Rst, Fin\n"
	 "\n"
	 "Examples:\n"
	 "   ipidscan -Fsa -d www.whitehouse.gov -s idlehost.saddam.iq\n"
	 "   ipidscan -Fsa -v -o 256 -fs -d www.openbsd.org -s ntserver.saddam.iq\n"
	 "NOTE: Make sure the silent host is really silent before scanning.\n",
	 default_ports, silentport, offset, sleeptime, timeout, retries);
  exit(ret);
}

int getflags(const char *str)
{
  int c, ret = 0;
  for (c = 0; c < strlen(str); c++) {
    switch (str[c]) {
    case 'S':
    case 's':
      ret |= TH_SYN;
      break;
    case 'A':
    case 'a':
      ret |= TH_ACK;
      break;
    case 'R':
    case 'r':
      ret |= TH_RST;
      break;
    case 'F':
    case 'f':
      ret |= TH_FIN;
      break;
    default:
      fprintf(stderr, "Unknown flag '%c'\n", str[c]);
      exit(1);
    }
  }
  return ret;
}

/*
 * scan a single port
 */
int scan_port(int tcp_socket, long srcaddr, long spoofaddr, long dstaddr, int port)
{
  unsigned int ipid, ttl, srcport, seq, ack, window;   // sending packet
  unsigned char *buf; // the packet
  int c;
  unsigned short old_ipid, temp_ipid;
  struct servent *servent;
  char *serv;
  int r = 0;

  while (-1 == get_ipid(&old_ipid, srcaddr, spoofaddr, timeout, silentport, silentflags,verbose)) {
    printf("Getpid failed, retrying\n");
    if (r++ == retries) {
      return -1;
    }
  }
  
  ipid = rand() & 0xffff;
  ttl = (rand() & 0x3f) + 0x40;  // 128 -> 191
  srcport = rand() & 0xffff;
  seq = rand();
  ack = rand();
  window = 16384;
  
  if (-1 == libnet_init_packet(IP_MAXPACKET, &buf)) {
    perror("No memory for packet header");
    exit(1);
  }
  
  libnet_build_ip(LIBNET_TCP_H,                      /* Size of the payload */
		  IPTOS_LOWDELAY | IPTOS_THROUGHPUT, /* IP tos */
		  ipid,                              /* IP ID */
		  0,                                 /* Frag stuff */
		  ttl,                               /* TTL */
		  IPPROTO_TCP,                       /* Transport protocol */
		  spoofaddr,                         /* Source IP */
		  dstaddr,                           /* Destination IP */
		  NULL,                              /* Pointer to payload (none) */
		  0,                                 /* payload size */
		  buf);                              /* Packet header memory */
  
  libnet_build_tcp(srcport,                          /* Source TCP port */
		   port,                             /* Destination TCP port */
		   seq,                              /* Sequence number */
		   ack,                              /* Acknowledgement number */
		   dstflags,                           /* Control flags */
		   window,                           /* Window size */
		   0,                                /* Urgent pointer */
		   NULL,                             /* Pointer to payload (none) */
		   0,                                /* payload size */
		   buf + LIBNET_IP_H);               /* Packet header memory */
  
  libnet_do_checksum(buf, IPPROTO_TCP, LIBNET_TCP_H);

  //  usleep(sleeptime);

  if ((libnet_write_ip(tcp_socket, buf, LIBNET_TCP_H + LIBNET_IP_H)) < LIBNET_TCP_H + LIBNET_IP_H){
    fprintf(stderr, "libnet_write_ip\n");
  }
  
  libnet_destroy_packet(&buf);
  
  usleep(sleeptime); // 'cause it doesn't work without it

  if (-1 == get_ipid(&temp_ipid, srcaddr, spoofaddr, timeout, silentport, silentflags, verbose)) {
    printf("Second IP id fetch timed out, trying again\n");
    return -1;
  }

  setservent(0);
  serv = (servent = getservbyport(htons(port), "tcp")) ? servent->s_name : "unknown";
  
  c = (short)temp_ipid - (short)old_ipid;
  if (c == (getoffset() * 2)) {
    printf("Port %d/%s: open (diff: %d)\n", port, serv, c);
    return 1;
  } else if (c == getoffset()) {
    if (verbose) {
      printf("Port %d/%s: closed (diff %d)\n", port, serv, c);
    }
  } else {
    printf("Port %d/%s: Oddity! (diff %d). Offset wrong or ip id fetching error.\n",
	   port, serv, c);
  }
  return 0;
}

/*
 *
 */
int main(int argc, char **argv)
{
  int c;
  long srcaddr;
  long dstaddr;
  long spoofaddr;
  char *ports = strdup(default_ports); // 'cause it doesn't work without strdup() for some reason
  char *host_scan = NULL, *host_spoof = NULL;
  struct libnet_plist_chain plist;
  struct libnet_plist_chain *plist_p;
  unsigned short lp, hp;
  char *dev = NULL, *ebuf = "libnet/libpcap has no explaination";
  int counter = 0;
  int tcp_socket;
  int silentcheck = 0;
  int r;

  printf("ipidscan version %s by marvin\n", version);
  
  /*
   * Must do this without getopt to get default
   * values right
   */
  for (c = 0; c < argc; c++) {
    if (!strncmp("-h", argv[c], 3)) {
      usage(0);
    }
  }

  while ((c = getopt(argc, argv, "vd:s:p:f:T:F:i:o:ew:t:c:r:")) != EOF) {
    switch (c) {
    case 'v': /* verbose */
      verbose++;
      break;
    case 'd': /* victim/destination */
      host_scan = optarg;
      break;
    case 's': /* silent host */
      host_spoof = optarg;
      break;
    case 'p': /* port(s) */
      ports = optarg;
      break;
    case 'f': /* port(s) */
      dstflags = getflags(optarg);
      break;
    case 'T': /* silent dest port */
      silentport = atoi(optarg);
      break;
    case 'F': /* silent flags */
      silentflags = getflags(optarg);
      break;
    case 'i': /* interface */
      dev = optarg;
      break;
    case 'o': /* offset */
      offset = atoi(optarg);
      break;
    case 'e': /* little endian */
      lendian = 1;
      break;
    case 't': /* timeout */
      timeout = atoi(optarg);
      break;
    case 'w': /* wait before getting second ip */
      sleeptime = atoi(optarg);
      break;
    case 'c': /* silent check */
      silentcheck = 1;
      host_spoof = optarg;
      break;
    case 'r': /* retries */
      retries = atoi(optarg);
      break;
    default: /* cleanup after wrong arg */
      usage(1);
    }
  }
  
  if (!dev) {
    if (!(dev = pcap_lookupdev(ebuf))) {
      fprintf(stderr, "Can't find any device: %s\n", ebuf);
      return 1;
    }
  }
  
  if ((-1 == (srcaddr = htonl(libnet_get_ipaddr(NULL, dev, ebuf)))) || (!srcaddr)) {
    fprintf(stderr, "Can't get ip addr of interface '%s': %s\n", dev, ebuf);
    return 1;
  }

  printf("Using interface '%s' (ip %s)\n\n", dev, libnet_host_lookup(srcaddr, LIBNET_DONT_RESOLVE));

  /*
   * see if host is silent
   */
  if (silentcheck) {
    unsigned short a,b;
    spoofaddr = libnet_name_resolve(host_spoof, LIBNET_RESOLVE);
    for(;;) {
      r = 0;
      while (-1 == get_ipid(&a, srcaddr, spoofaddr, timeout, silentport, silentflags, verbose)) {
	if (++r == retries) {
	  printf("Timed out (%d seconds, %d tries)\n", timeout, retries);
	  return 3;
	}
      }
      usleep(sleeptime);
      if (-1 != get_ipid(&b, srcaddr, spoofaddr, timeout, silentport, silentflags, verbose)) {
	break;
      }
    }
    a = b - a;
    if (a == getoffset()) {
      printf("%s is silent\n", host_spoof);
      return 0;
    } else if (a < (getoffset())) {
      printf("Wrong offset? (diff was %d)\n", a);
      return 2;
    } else {
      printf("%s is not silent (diff was %d)\n", host_spoof, a);
      return 1;
    }
  }
  /*
   * END of 'see if host is silent'
   */

  if (!(host_scan && host_spoof)) {
    usage(1);
  }
  
  srcaddr = 0;
  dstaddr = libnet_name_resolve(host_scan, LIBNET_RESOLVE);
  spoofaddr = libnet_name_resolve(host_spoof, LIBNET_RESOLVE);
  
  plist_p = &plist;
  if (libnet_plist_chain_new(&plist_p, ports) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "Could not build port list\n");
  }
  
  if ((srcaddr == -1)
      || (dstaddr == -1)
      || (spoofaddr == -1)) {
    fprintf(stderr, "At least one address did not resolve\n");
    exit(1);
  }
  
  if ((tcp_socket = libnet_open_raw_sock(IPPROTO_RAW)) == -1) {
    perror("No socket");
    exit(1);
  }
  
  for(;;) {
    switch (libnet_plist_chain_next_pair(plist_p, &lp, &hp)) {
    case -1:
      perror("libnet_plist_chain_next_pair()");
      break;
    case 0:
      libnet_plist_chain_free(plist_p);
      libnet_close_raw_sock(tcp_socket);
      printf("\n%d port(s) open.\n", counter);
      /*
       *      EXIT POINT!!!
       */
      return 0;
    }
    for (c = lp; c <= hp; c++) {
      switch (scan_port(tcp_socket, srcaddr, spoofaddr, dstaddr, c)) {
      case 0:
	break;
      case 1:
	counter++;
	break;
      case -1:
	c--;
	break;
      }
    } /* port loop */
  } /* chain loop */

  /* NOT REACHED */

} /* main() */
